## mingw-w64-qt6-3d-6.10.0-1.src.tar.zst

=== tests/manual/audio-visualizer-qml/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(audio-visualizer-qml LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}")

find_package(Qt6 REQUIRED COMPONENTS 3DCore 3DQuick Core Gui Multimedia Qml Quick)

qt_add_executable(audio-visualizer-qml
    main.cpp
    touchsettings.cpp touchsettings.h
)

set_target_properties(audio-visualizer-qml PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

target_link_libraries(audio-visualizer-qml PUBLIC
    Qt::3DCore
    Qt::3DQuick
    Qt::Core
    Qt::Gui
    Qt::Multimedia
    Qt::Qml
    Qt::Quick
)

# Resources:
set(audio-visualizer-qml_resource_files
    "BarEntity.qml"
    "Visualizer.qml"
    "images/albumcover.png"
    "images/demotitle.png"
    "images/normalmap.png"
    "images/pausehoverpressed.png"
    "images/pausenormal.png"
    "images/playhoverpressed.png"
    "images/playnormal.png"
    "images/songtitle.png"
    "images/stopdisabled.png"
    "images/stophoverpressed.png"
    "images/stopnormal.png"
    "main.qml"
    "meshes/circle.obj"
    "meshes/progressbar.obj"
    "music/tiltshifted_lost_neon_sun.mp3"
    "music/visualization.raw"
)

qt6_add_resources(audio-visualizer-qml "audio-visualizer-qml"
    PREFIX
        "/"
    FILES
        ${audio-visualizer-qml_resource_files}
)

install(TARGETS audio-visualizer-qml
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== src/plugins/renderers/opengl/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from opengl.pro.

set(openGLRendererSources graphicshelpers/graphicscontext.cpp graphicshelpers/graphicscontext_p.h
    graphicshelpers/graphicshelperes2.cpp graphicshelpers/graphicshelperes2_p.h
    graphicshelpers/graphicshelperes3.cpp graphicshelpers/graphicshelperes3_p.h
    graphicshelpers/graphicshelperes3_1.cpp graphicshelpers/graphicshelperes3_1_p.h
    graphicshelpers/graphicshelperes3_2.cpp graphicshelpers/graphicshelperes3_2_p.h
    graphicshelpers/graphicshelpergl2.cpp graphicshelpers/graphicshelpergl2_p.h
    graphicshelpers/graphicshelpergl3_2.cpp graphicshelpers/graphicshelpergl3_2_p.h
    graphicshelpers/graphicshelpergl3_3.cpp graphicshelpers/graphicshelpergl3_3_p.h
    graphicshelpers/graphicshelpergl4.cpp graphicshelpers/graphicshelpergl4_p.h
    graphicshelpers/graphicshelperinterface_p.h
    graphicshelpers/imagesubmissioncontext.cpp graphicshelpers/imagesubmissioncontext_p.h
    graphicshelpers/qgraphicsutils_p.h
    graphicshelpers/submissioncontext.cpp graphicshelpers/submissioncontext_p.h
    graphicshelpers/texturesubmissioncontext.cpp graphicshelpers/texturesubmissioncontext_p.h
    io/glbuffer.cpp io/glbuffer_p.h
    managers/gl_handle_types_p.h
    managers/glresourcemanagers.cpp managers/glresourcemanagers_p.h
    renderer/commandexecuter.cpp renderer/commandexecuter_p.h
    renderer/frameprofiler_p.h
    renderer/glfence_p.h
    renderer/gllights.cpp renderer/gllights_p.h
    renderer/glshader.cpp renderer/glshader_p.h
    renderer/logging.cpp renderer/logging_p.h
    renderer/openglvertexarrayobject.cpp renderer/openglvertexarrayobject_p.h
    renderer/rendercommand.cpp renderer/rendercommand_p.h
    renderer/renderer.cpp renderer/renderer_p.h
    renderer/renderview.cpp renderer/renderview_p.h
    renderer/renderviewbuilder.cpp renderer/renderviewbuilder_p.h
    renderer/shaderparameterpack.cpp renderer/shaderparameterpack_p.h
    renderer/shadervariables_p.h
    textures/gltexture.cpp textures/gltexture_p.h
    textures/renderbuffer.cpp textures/renderbuffer_p.h
)

#####################################################################
## Static library used for Unit Tests:
#####################################################################

if(QT_FEATURE_private_tests)

    add_library(OpenGLRendererLib STATIC ${openGLRendererSources})

    target_include_directories(OpenGLRendererLib PUBLIC
        graphicshelpers
        io
        jobs
        managers
        renderer
        textures
    )

    target_link_libraries(OpenGLRendererLib
        PUBLIC
            Qt::3DCore
            Qt::3DCorePrivate
            Qt::3DRender
            Qt::3DRenderPrivate
            Qt::Core
            Qt::CorePrivate
            Qt::Gui
            Qt::GuiPrivate
            Qt::OpenGL
            Qt::OpenGLPrivate
    )

    target_compile_definitions(OpenGLRendererLib PRIVATE
        BUILD_QT3D_MODULE
        QT_BUILDING_QT
        QT_NO_FOREACH
    )

    set(openGLRendererImguiSources
            debug/imguirenderer.cpp debug/imguirenderer_p.h
            ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui.cpp
            ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui_draw.cpp
            ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui_tables.cpp
            ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui_widgets.cpp
    )

    qt_internal_extend_sbom(OpenGLRendererLib TYPE CUSTOM)
    qt_internal_extend_target(OpenGLRendererLib CONDITION NOT INTEGRITY
        SOURCES
            ${openGLRendererImguiSources}
        NO_PCH_SOURCES
            ${openGLRendererImguiSources} # various defines (e.g. IMGUI_DEFINE_MATH_OPERATORS)
        INCLUDE_DIRECTORIES
            debug
            ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui
        ATTRIBUTION_FILE_DIR_PATHS
            ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui
    )

endif()

#####################################################################
## OpenGLRendererPlugin Plugin:
#####################################################################

qt_internal_add_plugin(OpenGLRendererPlugin
    OUTPUT_NAME openglrenderer
    PLUGIN_TYPE renderers
    SOURCES
        main.cpp
        ${openGLRendererSources}
    DEFINES
        BUILD_QT3D_MODULE
        QT_BUILDING_QT
        QT_NO_FOREACH
    INCLUDE_DIRECTORIES
        graphicshelpers
        io
        jobs
        managers
        renderer
        textures
    LIBRARIES
        Qt::3DCore
        Qt::3DCorePrivate
        Qt::3DRender
        Qt::3DRenderPrivate
        Qt::Core
        Qt::CorePrivate
        Qt::Gui
        Qt::GuiPrivate
        Qt::OpenGL
        Qt::OpenGLPrivate
)

# QTransform conflicts
set_target_properties(OpenGLRendererPlugin PROPERTIES UNITY_BUILD OFF)

qt_internal_extend_target(OpenGLRendererPlugin CONDITION NOT INTEGRITY
    SOURCES
        debug/imguirenderer.cpp debug/imguirenderer_p.h
        ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui.cpp
        ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui_draw.cpp
        ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui_tables.cpp
        ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui/imgui_widgets.cpp
    INCLUDE_DIRECTORIES
        debug
        ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui
    ATTRIBUTION_FILE_DIR_PATHS
        ${PROJECT_SOURCE_DIR}/src/3rdparty/imgui
)

## Scopes:
#####################################################################

qt_internal_extend_target(OpenGLRendererPlugin CONDITION gcov
    COMPILE_OPTIONS
        -fprofile-arcs
        -ftest-coverage
    LINK_OPTIONS
        "-fprofile-arcs"
        "-ftest-coverage"
)

=== tests/auto/animation/qkeyframeanimation/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qkeyframeanimation.pro.

#####################################################################
## tst_qkeyframeanimation Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qkeyframeanimation LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qkeyframeanimation
    SOURCES
        tst_qkeyframeanimation.cpp
    LIBRARIES
        Qt::3DAnimation
        Qt::3DCore
        Qt::3DCorePrivate
        Qt::3DRender
        Qt::3DRenderPrivate
        Qt::Gui
)

#### Keys ignored in scope 1:.:.:qkeyframeanimation.pro:<TRUE>:
# TEMPLATE = "app"

=== tests/auto/animation/skeleton/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from skeleton.pro.

#####################################################################
## tst_skeleton Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_skeleton_anim LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_skeleton_anim
    SOURCES
        tst_skeleton.cpp
    INCLUDE_DIRECTORIES
        ../../core/common
    LIBRARIES
        Qt::3DAnimation
        Qt::3DAnimationPrivate
        Qt::3DCore
        Qt::3DCorePrivate
        Qt::CorePrivate
        Qt::Gui
)

#### Keys ignored in scope 1:.:.:skeleton.pro:<TRUE>:
# TEMPLATE = "app"

## Scopes:
#####################################################################

qt_internal_extend_target(tst_skeleton_anim CONDITION QT_FEATURE_private_tests
    SOURCES
        ../../core/common/qbackendnodetester.cpp ../../core/common/qbackendnodetester.h
        ../../core/common/testarbiter.h
)

=== tests/auto/input/qbuttonaxisinput/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qbuttonaxisinput.pro.

#####################################################################
## tst_qbuttonaxisinput Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qbuttonaxisinput LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qbuttonaxisinput
    SOURCES
        ../commons/testdevice.h
        ../commons/testdevice.cpp
        ../commons/testdeviceproxy.h
        tst_qbuttonaxisinput.cpp
    INCLUDE_DIRECTORIES
        ../../core/common
        ../commons
    LIBRARIES
        Qt::3DCore
        Qt::3DCorePrivate
        Qt::3DInput
        Qt::3DInputPrivate
        Qt::CorePrivate
        Qt::Gui
)

#### Keys ignored in scope 1:.:.:qbuttonaxisinput.pro:<TRUE>:
# TEMPLATE = "app"

## Scopes:
#####################################################################

qt_internal_extend_target(tst_qbuttonaxisinput CONDITION QT_FEATURE_private_tests
    SOURCES
        ../../core/common/qbackendnodetester.cpp ../../core/common/qbackendnodetester.h
        ../../core/common/testarbiter.h
)

=== tests/auto/render/effect/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from effect.pro.

#####################################################################
## tst_effect Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_effect LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_effect
    SOURCES
        tst_effect.cpp
    LIBRARIES
        Qt::3DCore
        Qt::3DCorePrivate
        Qt::3DRender
        Qt::3DRenderPrivate
        Qt::CorePrivate
        Qt::Gui
)

#### Keys ignored in scope 1:.:.:effect.pro:<TRUE>:
# TEMPLATE = "app"

## Scopes:
#####################################################################

include(../commons/commons.cmake)
qt3d_setup_common_render_test(tst_effect)

=== tests/auto/render/genericlambdajob/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from genericlambdajob.pro.

#####################################################################
## tst_genericlambdajob Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_genericlambdajob LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_genericlambdajob
    SOURCES
        tst_genericlambdajob.cpp
    LIBRARIES
        Qt::3DCore
        Qt::3DCorePrivate
        Qt::3DRender
        Qt::3DRenderPrivate
        Qt::CorePrivate
        Qt::Gui
)

#### Keys ignored in scope 1:.:.:genericlambdajob.pro:<TRUE>:
# TEMPLATE = "app"

## Scopes:
#####################################################################

include(../commons/commons.cmake)
qt3d_setup_common_render_test(tst_genericlambdajob USE_TEST_ASPECT)

=== tests/auto/render/opengl/graphicshelpergl3_3/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from graphicshelpergl3_3.pro.

#####################################################################
## tst_graphicshelpergl3_3 Test:
#####################################################################

qt_internal_add_test(tst_graphicshelpergl3_3
    SOURCES
        tst_graphicshelpergl3_3.cpp
)

#### Keys ignored in scope 1:.:.:graphicshelpergl3_3.pro:<TRUE>:
# TEMPLATE = "app"

## Scopes:
#####################################################################

include(../../commons/commons.cmake)
qt3d_setup_common_render_test(tst_graphicshelpergl3_3 USE_TEST_ASPECT)
include(${PROJECT_SOURCE_DIR}/src/plugins/renderers/opengl/opengl.cmake)
qt3d_setup_opengl_renderer_target(tst_graphicshelpergl3_3)

qt_internal_extend_target(tst_graphicshelpergl3_3 CONDITION gcov
    COMPILE_OPTIONS
        -fprofile-arcs
        -ftest-coverage
    LINK_OPTIONS
        "-fprofile-arcs"
        "-ftest-coverage"
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-3d
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.10.0
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='C++ and QML APIs for easy inclusion of 3D graphics (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qt3d.git"
msys2_references=(
  'archlinux: qt6-3d'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND CC-BY-4.0 AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-multimedia"
             "${MINGW_PACKAGE_PREFIX}-assimp"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('bd885ff3741f4b6e4e9b29e1dd05feeae834063c0ca84239f38e3f4eed78e9b7')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DINPUT_qt3d_assimp=system \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-3d() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
              "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
              "${MINGW_PACKAGE_PREFIX}-qt6-multimedia"
              "${MINGW_PACKAGE_PREFIX}-assimp")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 ${_pkgfn}/LICENSES/* -t "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-3d-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
